[Top][All Lists]
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
Re: Internal Error -- automake 1.8.3
From: |
Alexandre Duret-Lutz |
Subject: |
Re: Internal Error -- automake 1.8.3 |
Date: |
Sat, 10 Apr 2004 00:21:43 +0200 |
User-agent: |
Gnus/5.1003 (Gnus v5.10.3) Emacs/21.3.50 (gnu/linux) |
>>> "bdavidso" == bdavidso <address@hidden> writes:
bdavidso> Hi:
bdavidso> Can anyone shed any light on this? (building gnubg gnu backgammon)
bdavidso> address@hidden:~/gnubg$ automake --gnu Makefile
bdavidso> automake: ####################
bdavidso> automake: ## Internal Error ##
bdavidso> automake: ####################
bdavidso> automake: undefined condition `!USE_GTK' for `COMMON_LIBS'
[...]
Thank you for reporting this! I'm installing the following fix
on HEAD and branch-1-8.
2004-04-09 Alexandre Duret-Lutz <address@hidden>
* automake.in (handle_lib_objects): Pass the condition of
the variable definition to handle_LIBOBJS and handle_ALLOCA,
not the aggregated conditions.
* tests/Makefile.am (TESTS): Add libobj14.test.
* tests/libobj14.test: New file.
Report from Bill Davidson.
Index: NEWS
===================================================================
RCS file: /cvs/automake/automake/NEWS,v
retrieving revision 1.256.2.36
diff -u -r1.256.2.36 NEWS
--- NEWS 26 Mar 2004 21:01:02 -0000 1.256.2.36
+++ NEWS 9 Apr 2004 21:48:12 -0000
@@ -7,6 +7,9 @@
* Bugs introduced by 1.8:
+ - Fix an "internal error" when @LIBOBJS@ is used in a variable that is
+ not defined in the same conditions as the _LDADD that uses it.
+
- Do not warn when JAVAROOT is overridden, this is legitimate.
Bugs fixed in 1.8.3:
Index: automake.in
===================================================================
RCS file: /cvs/automake/automake/automake.in,v
retrieving revision 1.1526.2.9
diff -u -r1.1526.2.9 automake.in
--- automake.in 14 Mar 2004 07:26:58 -0000 1.1526.2.9
+++ automake.in 9 Apr 2004 21:48:16 -0000
@@ -1922,13 +1922,13 @@
}
elsif ($val =~ /^\@(LT)address@hidden/)
{
- handle_LIBOBJS ($subvar, $full_cond, $1);
+ handle_LIBOBJS ($subvar, $cond, $1);
$seen_libobjs = 1;
return $val;
}
elsif ($val =~ /^\@(LT)address@hidden/)
{
- handle_ALLOCA ($subvar, $full_cond, $1);
+ handle_ALLOCA ($subvar, $cond, $1);
return $val;
}
else
Index: tests/Makefile.am
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.am,v
retrieving revision 1.539.2.10
diff -u -r1.539.2.10 Makefile.am
--- tests/Makefile.am 29 Feb 2004 19:10:40 -0000 1.539.2.10
+++ tests/Makefile.am 9 Apr 2004 21:48:16 -0000
@@ -273,6 +273,7 @@
libobj11.test \
libobj12.test \
libobj13.test \
+libobj14.test \
library.test \
library2.test \
library3.test \
Index: tests/Makefile.in
===================================================================
RCS file: /cvs/automake/automake/tests/Makefile.in,v
retrieving revision 1.698.2.21
diff -u -r1.698.2.21 Makefile.in
--- tests/Makefile.in 7 Mar 2004 18:10:08 -0000 1.698.2.21
+++ tests/Makefile.in 9 Apr 2004 21:48:17 -0000
@@ -388,6 +388,7 @@
libobj11.test \
libobj12.test \
libobj13.test \
+libobj14.test \
library.test \
library2.test \
library3.test \
Index: tests/libobj14.test
===================================================================
RCS file: tests/libobj14.test
diff -N tests/libobj14.test
--- /dev/null 1 Jan 1970 00:00:00 -0000
+++ tests/libobj14.test 9 Apr 2004 21:48:17 -0000
@@ -0,0 +1,49 @@
+#!/bin/sh
+# Copyright (C) 2004 Free Software Foundation, Inc.
+#
+# This file is part of GNU Automake.
+#
+# GNU Automake is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# GNU Automake is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Automake; see the file COPYING. If not, write to
+# the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
+# Boston, MA 02111-1307, USA.
+
+# Regression test for an internal error when @LIBOBJS@ is used in
+# a variable that is not defined in the same conditions as the _LDADD
+# that uses it.
+# Report from Bill Davidson
+
+required=gcc
+. ./defs
+
+set -e
+
+cat >>configure.in <<'EOF'
+AC_PROG_CC
+AC_LIBSOURCE([bar.c])
+AM_CONDITIONAL([CASE], :)
+AC_OUTPUT
+EOF
+
+: >bar.c
+
+cat >>Makefile.am <<'EOF'
+COMMON_LIBS = @LIBOBJS@
+bin_PROGRAMS = foo
+if ! CASE
+foo_LDADD = $(COMMON_LIBS)
+endif
+EOF
+
+$ACLOCAL
+$AUTOMAKE
--
Alexandre Duret-Lutz